ItemEvent (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt.event, class: ItemEvent
Keywords: java.awt.event.ItemEvent class

# Class ItemEvent

java.lang.Object
java.util.EventObject
java.awt.AWTEvent
java.awt.event.ItemEvent

All Implemented Interfaces:
  `Serializable`

public class ItemEvent extends AWTEvent
A semantic event which indicates that an item was selected or deselected. This high-level event is generated by an ItemSelectable object (such as a List) when an item is selected or deselected by the user. The event is passed to every `ItemListener` object which registered to receive such events using the component's `addItemListener` method.

The object that implements the `ItemListener` interface gets this `ItemEvent` when the event occurs. The listener is spared the details of processing individual mouse movements and mouse clicks, and can instead process a "meaningful" (semantic) event like "item selected" or "item deselected".

An unspecified behavior will be caused if the `id` parameter of any particular `ItemEvent` instance is not in the range from `ITEM_FIRST` to `ITEM_LAST`.

The `stateChange` of any `ItemEvent` instance takes one of the following values:

- `ItemEvent.SELECTED`
- `ItemEvent.DESELECTED`

Assigning the value different from listed above will cause an unspecified behavior.

Since:
  1.1
See Also:
  - `ItemSelectable`
  - `ItemListener`
  - Tutorial: Writing an Item Listener
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DESELECTED`
  This state-change-value indicates that a selected item was deselected.
  `static final int`
  `ITEM_FIRST`
  The first number in the range of ids used for item events.
  `static final int`
  `ITEM_LAST`
  The last number in the range of ids used for item events.
  `static final int`
  `ITEM_STATE_CHANGED`
  This event id indicates that an item's state changed.
  `static final int`
  `SELECTED`
  This state-change value indicates that an item was selected.

  ### Fields declared in class AWTEvent

  `ACTION_EVENT_MASK, ADJUSTMENT_EVENT_MASK, COMPONENT_EVENT_MASK, consumed, CONTAINER_EVENT_MASK, FOCUS_EVENT_MASK, HIERARCHY_BOUNDS_EVENT_MASK, HIERARCHY_EVENT_MASK, id, INPUT_METHOD_EVENT_MASK, INVOCATION_EVENT_MASK, ITEM_EVENT_MASK, KEY_EVENT_MASK, MOUSE_EVENT_MASK, MOUSE_MOTION_EVENT_MASK, MOUSE_WHEEL_EVENT_MASK, PAINT_EVENT_MASK, RESERVED_ID_MAX, TEXT_EVENT_MASK, WINDOW_EVENT_MASK, WINDOW_FOCUS_EVENT_MASK, WINDOW_STATE_EVENT_MASK`
  Modifier and Type
  Field
  Description
  `static final long`
  `ACTION_EVENT_MASK`
  The event mask for selecting action events.
  `static final long`
  `ADJUSTMENT_EVENT_MASK`
  The event mask for selecting adjustment events.
  `static final long`
  `COMPONENT_EVENT_MASK`
  The event mask for selecting component events.
  `protected boolean`
  `consumed`
  Controls whether or not the event is sent back down to the peer once the source has processed it - false means it's sent to the peer; true means it's not.
  `static final long`
  `CONTAINER_EVENT_MASK`
  The event mask for selecting container events.
  `static final long`
  `FOCUS_EVENT_MASK`
  The event mask for selecting focus events.
  `static final long`
  `HIERARCHY_BOUNDS_EVENT_MASK`
  The event mask for selecting hierarchy bounds events.
  `static final long`
  `HIERARCHY_EVENT_MASK`
  The event mask for selecting hierarchy events.
  `protected int`
  `id`
  The event's id.
  `static final long`
  `INPUT_METHOD_EVENT_MASK`
  The event mask for selecting input method events.
  `static final long`
  `INVOCATION_EVENT_MASK`
  The event mask for selecting invocation events.
  `static final long`
  `ITEM_EVENT_MASK`
  The event mask for selecting item events.
  `static final long`
  `KEY_EVENT_MASK`
  The event mask for selecting key events.
  `static final long`
  `MOUSE_EVENT_MASK`
  The event mask for selecting mouse events.
  `static final long`
  `MOUSE_MOTION_EVENT_MASK`
  The event mask for selecting mouse motion events.
  `static final long`
  `MOUSE_WHEEL_EVENT_MASK`
  The event mask for selecting mouse wheel events.
  `static final long`
  `PAINT_EVENT_MASK`
  The event mask for selecting paint events.
  `static final int`
  `RESERVED_ID_MAX`
  The maximum value for reserved AWT event IDs.
  `static final long`
  `TEXT_EVENT_MASK`
  The event mask for selecting text events.
  `static final long`
  `WINDOW_EVENT_MASK`
  The event mask for selecting window events.
  `static final long`
  `WINDOW_FOCUS_EVENT_MASK`
  The event mask for selecting window focus events.
  `static final long`
  `WINDOW_STATE_EVENT_MASK`
  The event mask for selecting window state events.

  ### Fields declared in class EventObject

  `source`
  Modifier and Type
  Field
  Description
  `protected Object`
  `source`
  The object on which the Event initially occurred.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ItemEvent(ItemSelectable source, int id, Object item, int stateChange)`
  Constructs an `ItemEvent` object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Object`
  `getItem()`
  Returns the item affected by the event.
  `ItemSelectable`
  `getItemSelectable()`
  Returns the originator of the event.
  `int`
  `getStateChange()`
  Returns the type of state change (selected or deselected).
  `String`
  `paramString()`
  Returns a parameter string identifying this item event.

  ### Methods declared in class AWTEvent

  `consume, getID, isConsumed, setSource, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `consume()`
  Consumes this event, if this event can be consumed.
  `int`
  `getID()`
  Returns the event type.
  `protected boolean`
  `isConsumed()`
  Returns whether this event has been consumed.
  `void`
  `setSource(Object newSource)`
  Retargets an event to a new source.
  `String`
  `toString()`
  Returns a String representation of this object.

  ### Methods declared in class EventObject

  `getSource`
  Modifier and Type
  Method
  Description
  `Object`
  `getSource()`
  The object on which the Event initially occurred.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Field Details

  - ### ITEM_FIRST

    public static final int ITEM_FIRST
    The first number in the range of ids used for item events.
    See Also:
      - Constant Field Values

  - ### ITEM_LAST

    public static final int ITEM_LAST
    The last number in the range of ids used for item events.
    See Also:
      - Constant Field Values

  - ### ITEM_STATE_CHANGED

    public static final int ITEM_STATE_CHANGED
    This event id indicates that an item's state changed.
    See Also:
      - Constant Field Values

  - ### SELECTED

    public static final int SELECTED
    This state-change value indicates that an item was selected.
    See Also:
      - Constant Field Values

  - ### DESELECTED

    public static final int DESELECTED
    This state-change-value indicates that a selected item was deselected.
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ItemEvent

    public ItemEvent(ItemSelectable source, int id, Object item, int stateChange)
    Constructs an `ItemEvent` object.

    This method throws an `IllegalArgumentException` if `source` is `null`.

    Parameters:
      `source` - The `ItemSelectable` object that originated the event
      `id` - The integer that identifies the event type. For information on allowable values, see the class description for `ItemEvent`
      `item` - An object -- the item affected by the event
      `stateChange` - An integer that indicates whether the item was selected or deselected. For information on allowable values, see the class description for `ItemEvent`
    Throws:
      `IllegalArgumentException` - if `source` is null
    See Also:
      - `getItemSelectable()`
      - `AWTEvent.getID()`
      - `getStateChange()`

- ## Method Details

  - ### getItemSelectable

    public ItemSelectable getItemSelectable()
    Returns the originator of the event.
    Returns:
      the ItemSelectable object that originated the event.

  - ### getItem

    public Object getItem()
    Returns the item affected by the event.
    Returns:
      the item (object) that was affected by the event

  - ### getStateChange

    public int getStateChange()
    Returns the type of state change (selected or deselected).
    Returns:
      an integer that indicates whether the item was selected or deselected
    See Also:
      - `SELECTED`
      - `DESELECTED`

  - ### paramString

    public String paramString()
    Returns a parameter string identifying this item event. This method is useful for event-logging and for debugging.
    Overrides:
      `paramString` in class `AWTEvent`
    Returns:
      a string identifying the event and its attributes